<template>
  <div class="page-box" style="position: relative;">
    <el-form
      ref="formTourImSensitiveWordAllowRef"
      :size="layoutStore.defaultFormItemSize"
      label-width="120px"
      label-position="right"
      @submit.prevent
    >
      <filter-box :item-width="350" @search="refreshFormTourImSensitiveWordAllow()" @reset="resetFormTourImSensitiveWordAllow">
        <el-form-item label="白名单词汇">
          <el-input
            class="filter-item"
            v-model="formFilter.wordFilter"
            type="text"
            placeholder=""
            :clearable="true"
            :show-word-limit="false"
            maxlength=""
          />
        </el-form-item>
      </filter-box>
    </el-form>
    <table-box
      ref="formTourImSensitiveWordAllowTable"
      class="page-table"
      :data="formTourImSensitiveWordAllowTableWidgetDataList"
      :size="layoutStore.defaultFormItemSize"
      :row-config="{isCurrent: false, isHover: true}"
      :seq-config="{startIndex: ((formTourImSensitiveWordAllowTableWidgetCurrentPage - 1) * formTourImSensitiveWordAllowTableWidgetPageSize)}"
      :sort-config="{remote: true}"
      :hasExtend="true"
      @sort-change="formTourImSensitiveWordAllowTableWidget.onSortChange"
      @refresh="formTourImSensitiveWordAllowTableWidget.refreshTable()"
    >
      <template #operator>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          :disabled="!checkPermCodeExist('formTourImSensitiveWordAllow:formTourImSensitiveWordAllow:addTourImSensitiveWordAllow')"
          @click="onAddTourImSensitiveWordAllowClick()"
          >
          新建
        </el-button>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          :disabled="!checkPermCodeExist('formTourImSensitiveWordAllow:formTourImSensitiveWordAllow:exportTourImSensitiveWordAllow')"
          @click="onExportTourImSensitiveWordAllowClick()"
          >
          导出
        </el-button>
        <el-upload
          class="btn-import"
          :auto-upload="false"
          action=""
          :show-file-list="false"
          accept=".xls,.xlsx"
          style="display: inline-block;"
          :disabled="!checkPermCodeExist('formTourImSensitiveWordAllow:formTourImSensitiveWordAllow:importTourImSensitiveWordAllow')"
          :on-change="onImportTourImSensitiveWordAllowClick"
        >
          <template #trigger>
            <el-button
              type="primary"
              :size="layoutStore.defaultFormItemSize"
              :disabled="!checkPermCodeExist('formTourImSensitiveWordAllow:formTourImSensitiveWordAllow:importTourImSensitiveWordAllow')"
            >
              导入
            </el-button>
          </template>
        </el-upload>
      </template>
      <vxe-column title="序号" type="seq" :index="formTourImSensitiveWordAllowTableWidget.getTableIndex" :width="80" />
      <vxe-column title="白名单词汇" field="word" />
      <vxe-column title="操作" fixed="right">
        <template v-slot="scope">
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onEditTourImSensitiveWordAllowClick(scope.row)"
            :disabled="!checkPermCodeExist('formTourImSensitiveWordAllow:formTourImSensitiveWordAllow:editTourImSensitiveWordAllow')"
          >
            编辑
          </el-button>
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onDeleteTourImSensitiveWordAllowClick(scope.row)"
            :disabled="!checkPermCodeExist('formTourImSensitiveWordAllow:formTourImSensitiveWordAllow:deleteTourImSensitiveWordAllow')"
          >
            删除
          </el-button>
        </template>
      </vxe-column>
      <template slot="empty">
        <div class="table-empty unified-font">
          <img src="@/assets/img/empty.png">
          <span>暂无数据</span>
        </div>
      </template>
      <!-- 分页 -->
      <template #pagination>
        <el-row type="flex" justify="end" style="margin-top: 10px;">
          <el-pagination
            :total="formTourImSensitiveWordAllowTableWidgetTotalCount"
            :current-page="formTourImSensitiveWordAllowTableWidgetCurrentPage"
            :page-size="formTourImSensitiveWordAllowTableWidgetPageSize"
            :page-sizes="[10, 20, 50, 100]"
            layout="total, prev, pager, next, sizes"
            @current-change="formTourImSensitiveWordAllowTableWidget.onCurrentPageChange"
            @size-change="formTourImSensitiveWordAllowTableWidget.onPageSizeChange">
          </el-pagination>
        </el-row>
      </template>
    </table-box>
    <label v-if="subPage" class="page-close-box" @click="onCancel()">
      <img src="@/assets/img/back2.png" alt="">
    </label>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formTourImSensitiveWordAllow',
};
</script>

<script setup lang="ts">
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode, stringCase } from '@/common/utils';
import { TourImSensitiveWordAllowData } from '@/api/generated/tourImSensitiveWordAllowController';
import { TourImSensitiveWordAllowController } from '@/api/generated';
import FormEditTourImSensitiveWordAllow from '@/pages/SensitiveWord/formEditTourImSensitiveWordAllow.vue';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
  }>(),
  {
    subPage: 0,
  },
);

const formFilter = reactive({
  // 白名单词汇
  wordFilter: undefined,
});
const formFilterCopy = reactive({
  // 白名单词汇
  wordFilter: undefined,
});

const onCancel = () => {
  router.go(-1);
  layoutStore.removeCachePage(route.fullPath as string);
  route.meta.refreshParentCachedPage = true;
};

const onResume = () => {
  refreshFormTourImSensitiveWordAllow();
};

/**
 * 表格组件数据获取函数，返回Promise
 */
const loadFormTourImSensitiveWordAllowTableWidgetData = (params: ANY_OBJECT) => {
  if (params == null) params = {};
  params = {
    ...params,
    tourImSensitiveWordAllowDtoFilter: {
      word: formFilter.wordFilter,
    }
  };
  return new Promise((resolve, reject) => {
    TourImSensitiveWordAllowController.list(params).then(res => {
      resolve({
        dataList: res.data.dataList,
        totalCount: res.data.totalCount
      });
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 表格组件数据获取检测函数，返回true正常获取数据，返回false停止获取数据
 */
const loadFormTourImSensitiveWordAllowTableVerify = () => {
  formFilterCopy.wordFilter = formFilter.wordFilter;
  return true;
};
/**
 * 新建
 */
const onAddTourImSensitiveWordAllowClick = (row?: TourImSensitiveWordAllowData) => {
  let params: ANY_OBJECT = {
  };

  Dialog
    .show('新建', FormEditTourImSensitiveWordAllow, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formTourImSensitiveWordAllowTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 编辑
 */
const onEditTourImSensitiveWordAllowClick = (row?: TourImSensitiveWordAllowData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  Dialog
    .show('编辑', FormEditTourImSensitiveWordAllow, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formTourImSensitiveWordAllowTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 导出
 */
const onExportTourImSensitiveWordAllowClick = (row?: TourImSensitiveWordAllowData) => {
  let params: ANY_OBJECT = {
  };

  TourImSensitiveWordAllowController.export(params, '表格组件.xlsx').then(res => {
    ElMessage.success('导出成功');
  }).catch(e => {
    ElMessage.error(e.errorMessage);
  });
};
/**
 * 导入
 */
const onImportTourImSensitiveWordAllowClick = (file) => {
  let params: ANY_OBJECT = {
    importFile: file.raw,
    // 是否忽略表头
    skipHeader: false
  };

  TourImSensitiveWordAllowController.import(params).then(res => {
    ElMessage.success('导入成功');
    formTourImSensitiveWordAllowTableWidget.refreshTable();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
/**
 * 删除
 */
const onDeleteTourImSensitiveWordAllowClick = (row?: TourImSensitiveWordAllowData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  ElMessageBox.confirm('是否删除此记录？').then(res => {
    TourImSensitiveWordAllowController.delete(params).then(res => {
      ElMessage.success('删除成功');
      formTourImSensitiveWordAllowTableWidget.refreshTable(false, 1);
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
// 表格组件表格组件参数
const formTourImSensitiveWordAllowTableOptions: TableOptions<TourImSensitiveWordAllowData> = {
  loadTableData: loadFormTourImSensitiveWordAllowTableWidgetData,
  verifyTableParameter: loadFormTourImSensitiveWordAllowTableVerify,
  paged: true,
  rowSelection: false,
  orderFieldName: undefined,
  ascending: true,
};
// 表格组件表格组件
const formTourImSensitiveWordAllowTable = ref();
const formTourImSensitiveWordAllowTableWidget = useTable(formTourImSensitiveWordAllowTableOptions);
const {
  dataList: formTourImSensitiveWordAllowTableWidgetDataList,
  currentPage: formTourImSensitiveWordAllowTableWidgetCurrentPage,
  pageSize: formTourImSensitiveWordAllowTableWidgetPageSize,
  totalCount: formTourImSensitiveWordAllowTableWidgetTotalCount,
} = formTourImSensitiveWordAllowTableWidget;
const refreshFormTourImSensitiveWordAllow = () => {
  // 刷新段落
  formTourImSensitiveWordAllowTableWidget.refreshTable();
};
/**
 * 重置过滤值
 */
const resetFormTourImSensitiveWordAllow = () => {
  formFilter.wordFilter = undefined;
  formFilterCopy.wordFilter = undefined;
  refreshFormTourImSensitiveWordAllow();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormTourImSensitiveWordAllow();
};
const formInit = () => {
  refreshFormTourImSensitiveWordAllow();
};

onMounted(() => {
  formInit();
});

onActivated(() => {
  onResume();
});
</script>